#include <PCD8544.h> //Подключаем библиотеку LSD 5110
static PCD8544 lcd;

//Pin 1 (RST)	      Arduino цифровой порт D6
//Pin 2 (SCE)	      Arduino цифровой порт D7
//Pin 3 (D/C)	      Arduino цифровой порт D5
//Pin 4 (SDIN/MOSI)	Arduino цифровой порт D4
//Pin 5 (SCLK)    	Arduino цифровой порт D3
//Pin 6 Vcc	        +3.3V порт на arduino
//Pin 7 Bl	 подсветка (на землю arduino)
//Pin 8 Gnd	        На землю arduino

#include <Keypad.h>  //Подключаем библиотеку клавиатуры
      //Начало необходимого кода для клавиатуры
const byte ROWS = 4; //Четыре ряда
const byte COLS = 3; //Три колонки
char keys[ROWS][COLS] =
{	
  {'1','2','3'},
  {'4','5','6'},
  {'7','8','9'},
  {'*','0','#'}
};
byte rowPins[ROWS] = {12, 9, 8, 2};//Подключение рядов клавиатуры
byte colPins[COLS] = {10, 11, 13}; //Подключение колонок клавиатуры
Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );
      //Конец необходимого кода
      
//Объявление переменных 
int YES=0; //Счетчик правильных ответов
int NO=0;  //Счетчик неправильных ответов
int a;     //a*b
int b;
int x;     // х - это %
int y;     // y - это оценка
boolean valOnePresent = false; //Вал из присутствующих
boolean next = false;  //Следующий
boolean final = false; //Окончательный
String num1;           //Буфер ответа с клавиатуры 

void setup()
{
  lcd.begin(84, 48);
  lcd.setCursor(0, 1);
  lcd.print(" Table 1 to 9");
  lcd.setCursor(0, 3);
  lcd.print(" Author:Andrey");
  lcd.setCursor(0, 4);
  lcd.print("        Kuzmin");
  
  delay(8500);
  randomSeed(analogRead(0)); //Генератор случайных чисел
}

void loop()
{
  next = false;
  lcd.clear(); //Очистка ЖКИ, курсор в верхний левый угол 
  lcd.setCursor(40, 0);
  lcd.print ("{");
  lcd.print (y);
  lcd.print ("}");  
  lcd.print (x);
  lcd.print ("%");
  lcd.setCursor(0, 1); // Переходим в вторую строку
  a = random (2, 10);  // а - случайное число от 2 до 9
  b = random (2, 10);  // b - случайное число от 2 до 9
  lcd.print (a);       // вывод "a*b"
  lcd.print ("*");
  lcd.print (b);
  lcd.print ("=");
  lcd.setCursor(0, 5); //Курсор в строку 5 
      lcd.print( "YES-"); //Вывод правильных ответов
      lcd.print (YES);
  lcd.setCursor(50, 5);  //Курсор в строку 5, на 50 точек вправо
      lcd.print( "NO-"); //Вывод неправильных ответов
      lcd.print (NO);
  while (next != true)   //Пока next в состоянии false - ждём
{
  char key = keypad.getKey();
  
  //Начало ввода с клавиатуры num1
  if (key != NO_KEY && (key=='1'||key=='2'||key=='3'||key=='4'||key=='5'||key=='6'||key=='7'||key=='8'||key=='9'||key=='0'))
  {
    if (valOnePresent != true)  //Неправда
    { 
      num1 = num1 + key;
      int numLength = num1.length();         //Число колонок, занятых цифрой
      lcd.setCursor((15 - numLength)+14, 1); //Один пробел для оператора и смещение на 14 точек вправо
      lcd.print(num1); 
       final = true;
    }
  } //Конец ввода с клавиатуры num1
  
  else if (final == true && key != NO_KEY && key == '*') //"*" - это сброс num1
  {
    num1 = "";                     //"*" это сброс num1
    lcd.setCursor(0, 1);           //Переходим во вторую строку
    lcd.clearLine();               //Очистка линии, в которой находится курсор
    lcd.print (a);                 //Вывод на экран "a*b="
    lcd.print ("*");
    lcd.print (b);
    lcd.print ("=");
  }
    else if (final == true && key != NO_KEY && key == '#') //"#" - это равно
  {
    if (num1.toInt()==a*b) // Если ответ правильный
    {
      lcd.setCursor(0, 3);
      lcd.print( "BEPHO");
      YES++;
      lcd.setCursor(0, 5);
      lcd.print( "YES-");
      lcd.print (YES);
      delay(2500);
      next = true;
    }
    else if (num1.toInt()!=a*b) // Если ответ неправильный
    {
      lcd.setCursor(0, 3);
      lcd.print( "HEBEPHO = ");
      NO++;
      lcd.print(a*b);          // Вывод на экран правильного ответа
      lcd.setCursor(50, 5);
      lcd.print( "NO-");
      lcd.print (NO);
      delay(3500);
      next = true;
    }
    valOnePresent = false;
    final = false;
    num1 = "";  }
}
x=YES*100/(YES+NO);
if (x>=93)                //Оценка 5
{
y=5;}
else if (x>=85 &&  x<=92) //Оценка 4
{
y=4;
}
else if (x>=77 &&  x<=84) //Оценка 3
{
y=3;
}
else if (x<=76)           //Оценка 2
{
y=2;
}
}

